# Magic Square Quantum Game

This code is for the contest [QuTech-KPN Quantum Internet Programming Competition](https://qutech.nl/qutech-kpn-quantum-internet-programming-competition/)

Detailed instructions of the contest can be found [here](http://www.simulaqron.org/wp-content/uploads/2018/08/instructions.pdf)

This code makes use of [SimulaQron](http://www.simulaqron.org/), which is an application level simulator for a quantum internet that allows you to program your own quantum internet applications.

More information about [Mermin-Peres magic square game](https://en.wikipedia.org/wiki/Quantum_pseudo-telepathy#The_Mermin-Peres_magic_square_game).

## Dependencies

This code is written using [ElectronJS](https://electronjs.org/) for the front end and python to use SimulaQron in the backend.

To run SimulaQron you need `Python 3` with the packages
- twisted (`pip install twisted`)
- service_identity (`pip install service_identity`)
- qutip (`pip install qutip`) (`pip install numpy`, if numpy is not installed)

This application requires [npm](https://www.npmjs.com/get-npm). Check if npm is installed by running `npm -v`.

## Instructions to run the code

Inside path `DESCRIPTION/`, run `sh run_submission.sh`. This should start the application.

You can also run it manually as follows.

### Manual run

Inside path `gui/`

Run `npm install` the first time to install all dependencies.

To start the application, run `npm start`
