const swal = require('sweetalert2');

var alice_solution;                // Alice's measurement outcome
var alice_row;                     // Row number assigned to Alice 
var alice_m = [-1, -1, -1];        // Alice's Answer


// When start/refresh button is clicked
const AliceStart = document.getElementById('AliceStart');
if(AliceStart) { 
    AliceStart.addEventListener('click', function(event) {
        
        
        var fs = require('fs');
        // If Judge has not assigned row number
        if (!fs.existsSync('./files/AliceSolution.txt')) {
            swal({
                title: "The judge has not assigned you the Row number yet.",
                type: 'error',
                confirmButtonText: 'Ok'
            });
            return;
        }

        // Read Alice's Quantum Entanglement measurement solution
        var allText = fs.readFileSync('./files/AliceSolution.txt','utf8').split('\n')
        alice_row = allText[0];
        alice_solution = allText.slice(1, 4);

        const AliceRow = document.getElementById('AliceRow');
        if(AliceRow) {
            AliceRow.style.display = "block";
            AliceRow.innerHTML = "Hi Alice, you have been assigned Row number : " + alice_row;
        }        

        const AliceGetSolution = document.getElementById('AliceGetSolution');
        if(AliceGetSolution) {
            AliceGetSolution.style.display = "block";
        }

        const StartHead = document.getElementById('StartHead');
        if(StartHead) {
            StartHead.style.display = "block";
            StartHead.innerHTML = "Enter your values(0 or 1) for Row number " + alice_row;
        } 

        // Initialize empty row
        document.getElementById('AliceM0').value = '';
        document.getElementById('AliceM1').value = '';
        document.getElementById('AliceM2').value = '';

        const Table = document.getElementById('Table');
        if(Table) {
            const RowNo = document.getElementById('RowNo');
            if(RowNo) {
                RowNo.innerHTML = "Row " + alice_row;
            }
            Table.style.display = "block";
        } 

        const AliceSubmit = document.getElementById('AliceSubmit');
        if(AliceSubmit) {
            AliceSubmit.style.display = "block";
        }

    });
}

// Use Alice's qubits measurement outcome
const AliceGetSolution = document.getElementById('AliceGetSolution');
if(AliceGetSolution) { 
    AliceGetSolution.addEventListener('click', function(event) {
        document.getElementById('AliceM0').value = alice_solution[0];
        document.getElementById('AliceM1').value = alice_solution[1];
        document.getElementById('AliceM2').value = alice_solution[2];
        
    });
}

// Submit answer to Judge
const AliceSubmit = document.getElementById('AliceSubmit');
if(AliceSubmit) { 
    AliceSubmit.addEventListener('click', function(event) {
        console.log(alice_solution)
        alice_m[0] = document.getElementById('AliceM0').value;
        alice_m[1] = document.getElementById('AliceM1').value;
        alice_m[2] = document.getElementById('AliceM2').value;
        console.log(alice_m);

        if(!CheckConstraint(alice_m)) {
            return;
        }

        var fs = require('fs');
        var content = alice_m[0] + "\n" + alice_m[1] + "\n" + alice_m[2] + "\n";
        fs.writeFile('./files/AliceAttempt.txt', content, function (err) {
            if (err) throw err;
            console.log('Saved!');
        }); 
        swal({
            title: "Alice, your answer has been submitted to the judge",
            type: 'info',
            confirmButtonText: 'Cool'
        });

        const AliceRow = document.getElementById('AliceRow');
        if(AliceRow) {
            AliceRow.style.display = "none";
        }        

        const AliceGetSolution = document.getElementById('AliceGetSolution');
        if(AliceGetSolution) {
            AliceGetSolution.style.display = "none";
        }

        const StartHead = document.getElementById('StartHead');
        if(StartHead) {
            StartHead.style.display = "none";
        } 

        const Table = document.getElementById('Table');
        if(Table) {
            Table.style.display = "none";
        } 

        const AliceSubmit = document.getElementById('AliceSubmit');
        if(AliceSubmit) {
            AliceSubmit.style.display = "none";
        }
    });
}

// Check constraints in Alice's row's textboxes
function CheckConstraint(alice_m) {
    if(alice_m[0] != '0' && alice_m[0] != '1') {
        swal({
            title: "Enter a value of 0 or 1 in column 1",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }
    if(alice_m[1] != '0' && alice_m[1] != '1') {
        swal({
            title: "Enter a value of 0 or 1 in column 2",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }
    if(alice_m[2] != '0' && alice_m[2] != '1') {
        swal({
            title: "Enter a value of 0 or 1 in column 3",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }

    var sum = parseInt(alice_m[0]) + parseInt(alice_m[1]) + parseInt(alice_m[2]);
    if((sum % 2) != 0) {
        swal({
            title: "There should be even number of 1s in the row.",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }
    return true;
}