const swal = require('sweetalert2');

var bob_solution;              // Bob's qubits measurement outcome
var bob_col;                   // Column number assigned to Bob
var bob_m = [-1, -1, -1];      // Bob's answer

// When start/refresh button is clicked
const BobStart = document.getElementById('BobStart');
if(BobStart) { 
    BobStart.addEventListener('click', function(event) {
        
        var fs = require('fs');
        // If Judge has not assigned row number
        if (!fs.existsSync('./files/BobSolution.txt')) {
            swal({
                title: "The judge has not assigned you the Column number yet.",
                type: 'error',
                confirmButtonText: 'Ok'
            });
            return;
        }

        // Read Bob's Quantum Entanglement measurement solution
        var allText = fs.readFileSync('./files/BobSolution.txt','utf8').split('\n');
        bob_col = allText[0];
        bob_solution = allText.slice(1, 4);

        const BobCol = document.getElementById('BobCol');
        if(BobCol) {
            BobCol.style.display = "block";
            BobCol.innerHTML = "Hi Bob, you have been assigned Column number : " + bob_col;
        }        

        const BobGetSolution = document.getElementById('BobGetSolution');
        if(BobGetSolution) {
            BobGetSolution.style.display = "block";
        }

        const StartHead = document.getElementById('StartHead');
        if(StartHead) {
            StartHead.style.display = "block";
            StartHead.innerHTML = "Enter your values(0 or 1) for Column number " + bob_col;
        } 

        // Initialize empty column
        document.getElementById('BobM0').value = '';
        document.getElementById('BobM1').value = '';
        document.getElementById('BobM2').value = '';


        const Table = document.getElementById('Table');
        if(Table) {
            const ColNo = document.getElementById('ColNo');
            if(ColNo) {
                ColNo.innerHTML = "Column " + bob_col;
            }
            Table.style.display = "block";
        } 

        const BobSubmit = document.getElementById('BobSubmit');
        if(BobSubmit) {
            BobSubmit.style.display = "block";
        }

        
    });
}

// Use Bob's qubits measurement outcome
const BobGetSolution = document.getElementById('BobGetSolution');
if(BobGetSolution) { 
    BobGetSolution.addEventListener('click', function(event) {
        document.getElementById('BobM0').value = bob_solution[0];
        document.getElementById('BobM1').value = bob_solution[1];
        document.getElementById('BobM2').value = bob_solution[2];
        
    });
}

// Submit answer to Judge
const BobSubmit = document.getElementById('BobSubmit');
if(BobSubmit) { 
    BobSubmit.addEventListener('click', function(event) {
        console.log(bob_solution)
        bob_m[0] = document.getElementById('BobM0').value;
        bob_m[1] = document.getElementById('BobM1').value;
        bob_m[2] = document.getElementById('BobM2').value;
        console.log(bob_m);
        
        if(!CheckConstraint(bob_m)) {
            return;
        }

        var fs = require('fs');
        var content = bob_m[0] + "\n" + bob_m[1] + "\n" + bob_m[2] + "\n";
        fs.writeFile('./files/BobAttempt.txt', content, function (err) {
            if (err) throw err;
            console.log('Saved!');
        });
        swal({
            title: "Bob, your answer has been submitted to the judge",
            type: 'info',
            confirmButtonText: 'Cool'
        });

        const BobCol = document.getElementById('BobCol');
        if(BobCol) {
            BobCol.style.display = "none";
        }        

        const BobGetSolution = document.getElementById('BobGetSolution');
        if(BobGetSolution) {
            BobGetSolution.style.display = "none";
        }

        const StartHead = document.getElementById('StartHead');
        if(StartHead) {
            StartHead.style.display = "none";
        } 

        const Table = document.getElementById('Table');
        if(Table) {
            Table.style.display = "none";
        } 

        const BobSubmit = document.getElementById('BobSubmit');
        if(BobSubmit) {
            BobSubmit.style.display = "none";
        }
    });
}

// Check constraints in Bob's column's textboxes
function CheckConstraint(bob_m) {
    if(bob_m[0] != '0' && bob_m[0] != '1') {
        swal({
            title: "Enter a value of 0 or 1 in row 1",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }
    if(bob_m[1] != '0' && bob_m[1] != '1') {
        swal({
            title: "Enter a value of 0 or 1 in row 2",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }
    if(bob_m[2] != '0' && bob_m[2] != '1') {
        swal({
            title: "Enter a value of 0 or 1 in row 3",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }

    var sum = parseInt(bob_m[0]) + parseInt(bob_m[1]) + parseInt(bob_m[2]);
    if((sum % 2) != 1) {
        swal({
            title: "There should be odd number of 1s in the column.",
            type: 'error',
            confirmButtonText: 'Ok'
        });
        return false;
    }
    return true;
}