const shell = require('shelljs');
const path = require('path');
const BrowserWindow = require('electron').remote.BrowserWindow;
const url = require('url');

const swal = require('sweetalert2')

// Open Strategy window
const StartStrategy = document.getElementById('StartStrategy');
if(StartStrategy) {
    StartStrategy.addEventListener('click', function(event) {
        console.log(path.join(__dirname, './../templates/strategy.html'));
        let StrategyWindow = new BrowserWindow({width: 800, height: 600});
        StrategyWindow.loadURL(url.format({
        pathname: path.join(__dirname, './../templates/strategy.html'),
        protocol: 'file:',
        slashes: true
      }));
    });
}

// Open Alice's window
const StartAlice = document.getElementById('StartAlice');
if(StartAlice) {
    StartAlice.addEventListener('click', function(event) {
        console.log(path.join(__dirname, './../templates/alice.html'));
        let AliceWindow = new BrowserWindow({width: 800, height: 600});
        AliceWindow.loadURL(url.format({
        pathname: path.join(__dirname, './../templates/alice.html'),
        protocol: 'file:',
        slashes: true
      }));
    });
}

// Open Bob's window
const StartBob = document.getElementById('StartBob');
if(StartBob) {
    StartBob.addEventListener('click', function(event) {
        console.log(path.join(__dirname, './../templates/bob.html'));
        let BobWindow = new BrowserWindow({width: 800, height: 600});
        BobWindow.loadURL(url.format({
        pathname: path.join(__dirname, './../templates/bob.html'),
        protocol: 'file:',
        slashes: true
      }));
    });
}

// Open Judge's window
const StartJudge = document.getElementById('StartJudge');
if(StartJudge) {
    StartJudge.addEventListener('click', function(event) {

        console.log('export NETSIM='+path.join(__dirname, '../../engine/SimulaQron'));
        shell.env["NETSIM"] = path.join(__dirname, '../../engine/SimulaQron');

        console.log('export PYTHONPATH='+path.join(__dirname, '../../engine') + ':$PYTHONPATH');
        shell.env["PYTHONPATH"] = path.join(__dirname, '../../engine') + ':$PYTHONPATH';

        shell.exec('sh ../engine/SimulaQron/run/startAll.sh Alice Bob', function(code, stdout, stderr) {
          console.log('Exit code:', code);
          console.log('Program output:', stdout);
          console.log('Program stderr:', stderr);
        });
        
        console.log('worked!');

        console.log(path.join(__dirname, './../templates/judge.html'));
        let JudgeWindow = new BrowserWindow({width: 800, height: 600});
        JudgeWindow.loadURL(url.format({
        pathname: path.join(__dirname, './../templates/judge.html'),
        protocol: 'file:',
        slashes: true
      }));
    });
}
